function MTestStieSoftICA()
    ns = [4, 16, 64, 256, 1024, 2048];
    ps = [2, 8,  32, 128, 512, 1024];
    nums = [128, 128, 32, 8, 2, 2];
    numruns = 50;
    tabtime = zeros(numruns, length(ns));
    tabiter = zeros(numruns, length(ns));
    tabnumf = zeros(numruns, length(ns));
    
    for k = 1 : length(ns)
        n = ns(k);
        p = ps(k);
        num = nums(k);
        for h = 1 : numruns
            rand('twister', h - 1);
            C = rand(n, n, num);
            for i = 1 : num
                C(:, :, i) = C(:, :, i) + C(:, :, i)';
            end
            tmpx0 = rand(n, p);
            [x0, ~] = qr(tmpx0, 0);
            
            SolverParams.method = 'RSD';
            SolverParams.DEBUG = 1;
            SolverParams.Max_Iteration = 30;
            SolverParams.LS_ratio1 = 0.5;
            SolverParams.Ls_ratio2 = 0.5;
            SolverParams.InitSteptype = 2;
            HasHHR = 0;
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funSeries, gradSeries, timeSeries] = TestStieSoftICA(C, x0, n, p, HasHHR, 1, SolverParams);
            
            tabtime(h, k) = ComTime;
            tabiter(h, k) = iter;
            tabnumf(h, k) = nf;
        end
    end
    dlmwrite('ROPTLIB_time', tabtime);
    dlmwrite('ROPTLIB_iter', tabiter);
    dlmwrite('ROPTLIB_numf', tabnumf);
end
