function PlotSoftICA()
%     Mi = load('Manopt_iter');
    Mt = load('Manopt_time');
    Mf = load('Manopt_numf');
    
%     Pi = load('Pymanopt_iter');
    Pt = load('Pymanopt_time');
    Pf = load('Manopt_numf'); % Python has the same implementation as Manopt.
    Pat = load('Pymanopt_auto_time');
    Paf = load('Manopt_numf'); % Python has the same implementation as Manopt.
    
%     Ri = load('ROPTLIB_iter');
    Rt = load('ROPTLIB_time');
    Rf = load('ROPTLIB_numf');

    [numruns, ns] = size(Mt);

    tab = zeros(8, ns);
    
    tab(1, :) = sum(Rt) / size(Rt, 1);
    tab(2, :) = sum(Rf) / size(Rf, 1);
    tab(3, :) = sum(Mt) / size(Mt, 1);
    tab(4, :) = sum(Mf) / size(Mf, 1);
    tab(5, :) = sum(Pt) / size(Pt, 1);
    tab(6, :) = sum(Pf) / size(Pf, 1);
    tab(7, :) = sum(Pat) / size(Pat, 1);
    tab(8, :) = sum(Paf) / size(Paf, 1);
    
    fout = fopen(['ROPTLIB_benchmark.txt'],'w');
    for i = 1 : size(tab, 1)
        for j = 1 : size(tab, 2)
            if(mod(i, 2) == 0)
                tabstr = num2str(floor(tab(i, j)));
            else
                tabstr = outputfloat(tab(i, j));
            end
            if(j < size(tab, 2))
                fprintf(fout,['$' tabstr '$ & ']);
            else
                fprintf(fout,['$' tabstr '$']);
            end
        end
        fprintf(fout,' \\\\\n');
    end
    fclose(fout);
end


function str = outputfloat(x)
    if(x < 1e0)
        str = sprintf('%.3f', x);
    elseif(x < 1e1)
        str = sprintf('%.3f', x);
    elseif(x < 1e2)
        str = sprintf('%.2f', x);
    else
        str = sprintf('%.1f', x);
    end

%     if(x <= 0)
%         str = '';
%         return;
%     end
%     p = log(x)/log(10);
%     p = - ceil(-p);
%     x = round(x * 10^(-p) * 100);
%     x = x / 100;
%     strx = sprintf('%3.2f', x);
%     if(p ~= 0)
%         str = [strx '_{' num2str(p) '}'];
%     else
%         str = strx;
%     end
end
