function LRMC()
    ms = [100, 1000];
    ns = [200, 2000];
    r = 10;
    seed = floor(rand() * 10000000);
    seed = 1;

    ntest = 50;
    nmethod = 5;
    tab = zeros(8, nmethod * length(ms), ntest); %LRBFGS LRTRSR1 RCG RNewton RTRNewton

    rand('state', seed);
    randn('state', seed);
    for h = 1 : length(ms)
        m = ms(h);
        n = ns(h);
        for k = 1 : ntest
            G = randn(m, r);
            H = randn(n, r);
            B = G * H';
            OS = 3;
            nz = min((m + n - r) * r * OS, m * n);

            vidx = randperm(m * n, nz);
            [ir, jc] = ind2sub([m, n], vidx);
            A = sparse(ir, jc, B(vidx));
            [U, D, V] = svds(full(A),r);
%             U = orth(randn(m, r));
%             D = randn(r,r);
%             V = orth(randn(n, r));
            Xinitial = [U(:); D(:); V(:)];
            
            SolverParams.method = 'LRBFGS';
            SolverParams.Max_Iteration = 1000;
            SolverParams.DEBUG = 1;
            HasHHR = 0;
            fprintf('start LRBFGS\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestLRMatrixCompletion(A, Xinitial, r, HasHHR, SolverParams);
            ii = 4;
            tab(1, nmethod * h - ii, k) = iter;
            tab(2, nmethod * h - ii, k) = nf;
            tab(3, nmethod * h - ii, k) = ng;
            tab(4, nmethod * h - ii, k) = nR;
            tab(5, nmethod * h - ii, k) = nV + nVp;
            tab(6, nmethod * h - ii, k) = gfgf0;
            tab(7, nmethod * h - ii, k) = ComTime;
            tab(8, nmethod * h - ii, k) = f;

            SolverParams.method = 'LRTRSR1';
            HasHHR = 0;
            fprintf('start LRTRSR1\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestLRMatrixCompletion(A, Xinitial, r, HasHHR, SolverParams);
            ii = 3;
            tab(1, nmethod * h - ii, k) = iter;
            tab(2, nmethod * h - ii, k) = nf;
            tab(3, nmethod * h - ii, k) = ng;
            tab(4, nmethod * h - ii, k) = nR;
            tab(5, nmethod * h - ii, k) = nV + nVp;
            tab(6, nmethod * h - ii, k) = gfgf0;
            tab(7, nmethod * h - ii, k) = ComTime;
            tab(8, nmethod * h - ii, k) = f;

            SolverParams.method = 'RCG';
            HasHHR = 0;
            fprintf('start RCG\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestLRMatrixCompletion(A, Xinitial, r, HasHHR, SolverParams);
            ii = 2;
            tab(1, nmethod * h - ii, k) = iter;
            tab(2, nmethod * h - ii, k) = nf;
            tab(3, nmethod * h - ii, k) = ng;
            tab(4, nmethod * h - ii, k) = nR;
            tab(5, nmethod * h - ii, k) = nV + nVp;
            tab(6, nmethod * h - ii, k) = gfgf0;
            tab(7, nmethod * h - ii, k) = ComTime;
            tab(8, nmethod * h - ii, k) = f;

            SolverParams.method = 'RNewton';
            HasHHR = 0;
            fprintf('start RNewton\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestLRMatrixCompletion(A, Xinitial, r, HasHHR, SolverParams);
            ii = 1;
            tab(1, nmethod * h - ii, k) = iter;
            tab(2, nmethod * h - ii, k) = nf;
            tab(3, nmethod * h - ii, k) = ng;
            tab(4, nmethod * h - ii, k) = nR;
            tab(5, nmethod * h - ii, k) = nV + nVp;
            tab(6, nmethod * h - ii, k) = gfgf0;
            tab(7, nmethod * h - ii, k) = ComTime;
            tab(8, nmethod * h - ii, k) = f;

            SolverParams.method = 'RTRNewton';
            HasHHR = 0;
            fprintf('start RTRNewton\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestLRMatrixCompletion(A, Xinitial, r, HasHHR, SolverParams);
            ii = 0;
            tab(1, nmethod * h - ii, k) = iter;
            tab(2, nmethod * h - ii, k) = nf;
            tab(3, nmethod * h - ii, k) = ng;
            tab(4, nmethod * h - ii, k) = nR;
            tab(5, nmethod * h - ii, k) = nV + nVp;
            tab(6, nmethod * h - ii, k) = gfgf0;
            tab(7, nmethod * h - ii, k) = ComTime;
            tab(8, nmethod * h - ii, k) = f;

        end
        totaltab = 0;
        for i = 1 : ntest
            totaltab = totaltab + tab(:, :, i);
        end
        totaltab = totaltab / ntest;
        totaltab;
        tabiter(:, h) = totaltab(2, :)';
        tabtime(:, h) = totaltab(7, :)';
    end
    save('LRMCmethods.mat', 'tab', 'tabiter', 'tabtime')
end


