function LRMC_form()
    inputfile = load('LRMCmethods.mat');
    tab = inputfile.tab;
    totaltab = 0;
    num = size(tab, 3);
    for i = 1 : num
        totaltab = totaltab + tab(:, :, i);
    end
    totaltab = totaltab / num;
    
    strs = {'iter', 'nf', 'ng', 'nR', 'nV', 'gf/gf0', 't', 'f'};
    fout = fopen(['LRMCmethods.txt'],'w');
    for i = 1 : 8
        fprintf(fout, '\\hline\n');
        fprintf(fout, strs{i});
        fprintf(fout, ' & ');
        for j = 1 : 10
            
            if i <= 5
                tabstr = outputfloat(totaltab(i, j));
                if(j < 10)
                    fprintf(fout,['$' num2str(round(totaltab(i, j))) '$ & ']);
                else
                    fprintf(fout,['$' num2str(round(totaltab(i, j))) '$']);
                end
            else
                tabstr = outputfloat(totaltab(i, j));
                if(j < 10)
                    fprintf(fout,['$' tabstr '$ & ']);
                else
                    fprintf(fout,['$' tabstr '$']);
                end
            end
        end
        fprintf(fout,' \\\\\n');
    end
    fprintf(fout, '\\hline\n');
    fclose(fout);
end


function str = outputfloat(x)
    if(x <= 0)
        str = '';
        return;
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [strx '_{' num2str(p) '}'];
    else
        str = strx;
    end
end
