function SPDTensorDL_RCGvsLRBFGS()
    dim = 4; %20
    numb = 10; %100
    N = 500; %500
    numatomsb = 3; %10
    r = floor(rand() * 10000000);
    r = 1;

    times = [1, 2, 3, 4, 5];%, 6, 7, 8];
    ntest = 50;
    tab = zeros(7, 2 * length(times), ntest);

    rand('state', r);
    randn('state', r);
    for h = 1 : length(times)
        num = numb * times(h);
        numatoms = numatomsb * times(h);
        for k = 1 : ntest

            Xtrue = zeros(dim, dim, num);
            for i = 1 : num
                tmp = randn(dim, dim * 10);
                Xtrue(:, :, i) = tmp * tmp';
            end

            alpha = zeros(num, N);
            for i = 1 : N
                values = rand(numatoms, 1);
                idx = randperm(num, numatoms);
                for j = 1 : numatoms
                    alpha(idx(j), i) = values(j);
                end
            end
            Xalpha = reshape(Xtrue, dim * dim, num) * alpha;
            As = reshape(Xalpha, dim, dim, N);

            Ls = zeros(dim, dim, N);
            for i = 1 : N
                Ls(:, :, i) = chol(As(:, :, i), 'lower');
            end

            Xinitial = reshape(Xalpha * max(pinv(alpha), 0), dim, dim, num);

            SolverParams.method = 'LRBFGS';
            SolverParams.Max_Iteration = 1000;
            SolverParams.DEBUG = 1;
            HasHHR = 0;
            fprintf('start LRBFGS\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestSPDTensorDL(Ls, alpha, Xinitial, 1, HasHHR, SolverParams);
            tab(1, 1 * 2 - 1 + 2 * h - 2, k) = iter;
            tab(2, 1 * 2 - 1 + 2 * h - 2, k) = nf;
            tab(3, 1 * 2 - 1 + 2 * h - 2, k) = ng;
            tab(4, 1 * 2 - 1 + 2 * h - 2, k) = nR;
            tab(5, 1 * 2 - 1 + 2 * h - 2, k) = nV + nVp;
            tab(6, 1 * 2 - 1 + 2 * h - 2, k) = gfgf0;
            tab(7, 1 * 2 - 1 + 2 * h - 2, k) = ComTime;

            SolverParams.method = 'RCG';
            HasHHR = 0;
            fprintf('start RCG\n');
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime] = TestSPDTensorDL(Ls, alpha, Xinitial, 1, HasHHR, SolverParams);
            tab(1, 1 * 2 + 2 * h - 2, k) = iter;
            tab(2, 1 * 2 + 2 * h - 2, k) = nf;
            tab(3, 1 * 2 + 2 * h - 2, k) = ng;
            tab(4, 1 * 2 + 2 * h - 2, k) = nR;
            tab(5, 1 * 2 + 2 * h - 2, k) = nV + nVp;
            tab(6, 1 * 2 + 2 * h - 2, k) = gfgf0;
            tab(7, 1 * 2 + 2 * h - 2, k) = ComTime;
        end
        totaltab = 0;
        for i = 1 : ntest
            totaltab = totaltab + tab(:, :, i);
        end
        totaltab = totaltab / ntest;
        totaltab;
        tabiter(:, h) = totaltab(2, :)';
        tabtime(:, h) = totaltab(7, :)';
    end
    save('SPDTensorDLLRBFGSRCG_times.mat', 'tab', 'tabiter', 'tabtime')
end


